G_BEGIN_DECLS

typedef void (*emp_cli_channel_interface_conference_signal_callback_channel_merged) (TpProxy *proxy,
    const gchar *arg_Channel,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_channel_interface_conference_connect_to_channel_merged (TpProxy *proxy,
    emp_cli_channel_interface_conference_signal_callback_channel_merged callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_channel_interface_conference_signal_callback_channel_removed) (TpProxy *proxy,
    const gchar *arg_Channel,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_channel_interface_conference_connect_to_channel_removed (TpProxy *proxy,
    emp_cli_channel_interface_conference_signal_callback_channel_removed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_debug_signal_callback_new_debug_message) (TpProxy *proxy,
    gdouble arg_time,
    const gchar *arg_domain,
    guint arg_level,
    const gchar *arg_message,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_debug_connect_to_new_debug_message (TpProxy *proxy,
    emp_cli_debug_signal_callback_new_debug_message callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_debug_callback_for_get_messages) (TpProxy *proxy,
    const GPtrArray *out_Messages,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_debug_call_get_messages (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_debug_callback_for_get_messages callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_debug_run_get_messages (TpProxy *proxy,
    gint timeout_ms,
    GPtrArray **out_Messages,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_logger_signal_callback_favourite_contacts_changed) (TpProxy *proxy,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed,
    gpointer user_data, GObject *weak_object);
TpProxySignalConnection *emp_cli_logger_connect_to_favourite_contacts_changed (TpProxy *proxy,
    emp_cli_logger_signal_callback_favourite_contacts_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error);

typedef void (*emp_cli_logger_callback_for_get_recent_messages) (TpProxy *proxy,
    const GPtrArray *out_Messages,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_get_recent_messages (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gboolean in_Is_Chatroom,
    guint in_Lines,
    emp_cli_logger_callback_for_get_recent_messages callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_logger_run_get_recent_messages (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gboolean in_Is_Chatroom,
    guint in_Lines,
    GPtrArray **out_Messages,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_logger_callback_for_get_favourite_contacts) (TpProxy *proxy,
    const GPtrArray *out_Favourite_Contacts,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_get_favourite_contacts (TpProxy *proxy,
    gint timeout_ms,
    emp_cli_logger_callback_for_get_favourite_contacts callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_logger_run_get_favourite_contacts (TpProxy *proxy,
    gint timeout_ms,
    GPtrArray **out_Favourite_Contacts,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_logger_callback_for_add_favourite_contact) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_add_favourite_contact (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    emp_cli_logger_callback_for_add_favourite_contact callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_logger_run_add_favourite_contact (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    GError **error,
    GMainLoop **loop);


typedef void (*emp_cli_logger_callback_for_remove_favourite_contact) (TpProxy *proxy,
    const GError *error, gpointer user_data,
    GObject *weak_object);

TpProxyPendingCall *emp_cli_logger_call_remove_favourite_contact (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    emp_cli_logger_callback_for_remove_favourite_contact callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object);

gboolean emp_cli_logger_run_remove_favourite_contact (TpProxy *proxy,
    gint timeout_ms,
    const gchar *in_Account,
    const gchar *in_Identifier,
    GError **error,
    GMainLoop **loop);


G_END_DECLS
